/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Account, Address, Codec, Decoder, EncodedAccount, Encoder, FetchAccountConfig, FetchAccountsConfig, MaybeAccount, MaybeEncodedAccount, Option, OptionOrNullable, fetchEncodedAccount, fetchEncodedAccounts } from '@solana/web3.js';
import { MetadataSeeds } from '../pdas';
import { Collection, CollectionArgs, CollectionDetails, CollectionDetailsArgs, Creator, CreatorArgs, Key, KeyArgs, ProgrammableConfig, ProgrammableConfigArgs, TokenStandard, TokenStandardArgs, Uses, UsesArgs } from '../types';
export type Metadata = {
    key: Key;
    updateAuthority: Address;
    mint: Address;
    name: string;
    symbol: string;
    uri: string;
    sellerFeeBasisPoints: number;
    creators: Option<Array<Creator>>;
    primarySaleHappened: boolean;
    isMutable: boolean;
    editionNonce: Option<number>;
    tokenStandard: Option<TokenStandard>;
    collection: Option<Collection>;
    uses: Option<Uses>;
    collectionDetails: Option<CollectionDetails>;
    programmableConfig: Option<ProgrammableConfig>;
};
export type MetadataArgs = {
    key: KeyArgs;
    updateAuthority: Address;
    mint: Address;
    name: string;
    symbol: string;
    uri: string;
    sellerFeeBasisPoints: number;
    creators: OptionOrNullable<Array<CreatorArgs>>;
    primarySaleHappened: boolean;
    isMutable: boolean;
    editionNonce: OptionOrNullable<number>;
    tokenStandard: OptionOrNullable<TokenStandardArgs>;
    collection: OptionOrNullable<CollectionArgs>;
    uses: OptionOrNullable<UsesArgs>;
    collectionDetails: OptionOrNullable<CollectionDetailsArgs>;
    programmableConfig: OptionOrNullable<ProgrammableConfigArgs>;
};
export declare function getMetadataEncoder(): Encoder<MetadataArgs>;
export declare function getMetadataDecoder(): Decoder<Metadata>;
export declare function getMetadataCodec(): Codec<MetadataArgs, Metadata>;
export declare function decodeMetadata<TAddress extends string = string>(encodedAccount: EncodedAccount<TAddress>): Account<Metadata, TAddress>;
export declare function decodeMetadata<TAddress extends string = string>(encodedAccount: MaybeEncodedAccount<TAddress>): MaybeAccount<Metadata, TAddress>;
export declare function fetchMetadata<TAddress extends string = string>(rpc: Parameters<typeof fetchEncodedAccount>[0], address: Address<TAddress>, config?: FetchAccountConfig): Promise<Account<Metadata, TAddress>>;
export declare function fetchMaybeMetadata<TAddress extends string = string>(rpc: Parameters<typeof fetchEncodedAccount>[0], address: Address<TAddress>, config?: FetchAccountConfig): Promise<MaybeAccount<Metadata, TAddress>>;
export declare function fetchAllMetadata(rpc: Parameters<typeof fetchEncodedAccounts>[0], addresses: Array<Address>, config?: FetchAccountsConfig): Promise<Account<Metadata>[]>;
export declare function fetchAllMaybeMetadata(rpc: Parameters<typeof fetchEncodedAccounts>[0], addresses: Array<Address>, config?: FetchAccountsConfig): Promise<MaybeAccount<Metadata>[]>;
export declare function fetchMetadataFromSeeds(rpc: Parameters<typeof fetchEncodedAccount>[0], seeds: MetadataSeeds, config?: FetchAccountConfig & {
    programAddress?: Address;
}): Promise<Account<Metadata>>;
export declare function fetchMaybeMetadataFromSeeds(rpc: Parameters<typeof fetchEncodedAccount>[0], seeds: MetadataSeeds, config?: FetchAccountConfig & {
    programAddress?: Address;
}): Promise<MaybeAccount<Metadata>>;
//# sourceMappingURL=metadata.d.ts.map