/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
export type BurnNftInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountOwner extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountTokenAccount extends string | IAccountMeta<string> = string, TAccountMasterEditionAccount extends string | IAccountMeta<string> = string, TAccountSplTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountCollectionMetadata extends string | IAccountMeta<string> | undefined = undefined, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountOwner extends string ? WritableSignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner,
    TAccountMint extends string ? WritableAccount<TAccountMint> : TAccountMint,
    TAccountTokenAccount extends string ? WritableAccount<TAccountTokenAccount> : TAccountTokenAccount,
    TAccountMasterEditionAccount extends string ? WritableAccount<TAccountMasterEditionAccount> : TAccountMasterEditionAccount,
    TAccountSplTokenProgram extends string ? ReadonlyAccount<TAccountSplTokenProgram> : TAccountSplTokenProgram,
    ...(TAccountCollectionMetadata extends undefined ? [] : [
        TAccountCollectionMetadata extends string ? WritableAccount<TAccountCollectionMetadata> : TAccountCollectionMetadata
    ]),
    ...TRemainingAccounts
]>;
export type BurnNftInstructionData = {
    discriminator: number;
};
export type BurnNftInstructionDataArgs = {};
export declare function getBurnNftInstructionDataEncoder(): Encoder<BurnNftInstructionDataArgs>;
export declare function getBurnNftInstructionDataDecoder(): Decoder<BurnNftInstructionData>;
export declare function getBurnNftInstructionDataCodec(): Codec<BurnNftInstructionDataArgs, BurnNftInstructionData>;
export type BurnNftInput<TAccountMetadata extends string = string, TAccountOwner extends string = string, TAccountMint extends string = string, TAccountTokenAccount extends string = string, TAccountMasterEditionAccount extends string = string, TAccountSplTokenProgram extends string = string, TAccountCollectionMetadata extends string = string> = {
    /** Metadata (pda of ['metadata', program id, mint id]) */
    metadata: Address<TAccountMetadata>;
    /** NFT owner */
    owner: TransactionSigner<TAccountOwner>;
    /** Mint of the NFT */
    mint: Address<TAccountMint>;
    /** Token account to close */
    tokenAccount: Address<TAccountTokenAccount>;
    /** MasterEdition2 of the NFT */
    masterEditionAccount: Address<TAccountMasterEditionAccount>;
    /** SPL Token Program */
    splTokenProgram?: Address<TAccountSplTokenProgram>;
    /** Metadata of the Collection */
    collectionMetadata?: Address<TAccountCollectionMetadata>;
};
export declare function getBurnNftInstruction<TAccountMetadata extends string, TAccountOwner extends string, TAccountMint extends string, TAccountTokenAccount extends string, TAccountMasterEditionAccount extends string, TAccountSplTokenProgram extends string, TAccountCollectionMetadata extends string>(input: BurnNftInput<TAccountMetadata, TAccountOwner, TAccountMint, TAccountTokenAccount, TAccountMasterEditionAccount, TAccountSplTokenProgram, TAccountCollectionMetadata>): BurnNftInstruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetadata, TAccountOwner, TAccountMint, TAccountTokenAccount, TAccountMasterEditionAccount, TAccountSplTokenProgram, TAccountCollectionMetadata>;
export type ParsedBurnNftInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Metadata (pda of ['metadata', program id, mint id]) */
        metadata: TAccountMetas[0];
        /** NFT owner */
        owner: TAccountMetas[1];
        /** Mint of the NFT */
        mint: TAccountMetas[2];
        /** Token account to close */
        tokenAccount: TAccountMetas[3];
        /** MasterEdition2 of the NFT */
        masterEditionAccount: TAccountMetas[4];
        /** SPL Token Program */
        splTokenProgram: TAccountMetas[5];
        /** Metadata of the Collection */
        collectionMetadata?: TAccountMetas[6] | undefined;
    };
    data: BurnNftInstructionData;
};
export declare function parseBurnNftInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedBurnNftInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=burnNft.d.ts.map