/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, ReadonlySignerAccount, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
export type CreateMasterEditionInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountEdition extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountUpdateAuthority extends string | IAccountMeta<string> = string, TAccountMintAuthority extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountRent extends string | IAccountMeta<string> = 'SysvarRent111111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountEdition extends string ? WritableAccount<TAccountEdition> : TAccountEdition,
    TAccountMint extends string ? WritableAccount<TAccountMint> : TAccountMint,
    TAccountUpdateAuthority extends string ? ReadonlySignerAccount<TAccountUpdateAuthority> & IAccountSignerMeta<TAccountUpdateAuthority> : TAccountUpdateAuthority,
    TAccountMintAuthority extends string ? ReadonlySignerAccount<TAccountMintAuthority> & IAccountSignerMeta<TAccountMintAuthority> : TAccountMintAuthority,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountMetadata extends string ? ReadonlyAccount<TAccountMetadata> : TAccountMetadata,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountRent extends string ? ReadonlyAccount<TAccountRent> : TAccountRent,
    ...TRemainingAccounts
]>;
export type CreateMasterEditionInstructionData = {
    discriminator: number;
};
export type CreateMasterEditionInstructionDataArgs = {};
export declare function getCreateMasterEditionInstructionDataEncoder(): Encoder<CreateMasterEditionInstructionDataArgs>;
export declare function getCreateMasterEditionInstructionDataDecoder(): Decoder<CreateMasterEditionInstructionData>;
export declare function getCreateMasterEditionInstructionDataCodec(): Codec<CreateMasterEditionInstructionDataArgs, CreateMasterEditionInstructionData>;
export type CreateMasterEditionInput<TAccountEdition extends string = string, TAccountMint extends string = string, TAccountUpdateAuthority extends string = string, TAccountMintAuthority extends string = string, TAccountPayer extends string = string, TAccountMetadata extends string = string, TAccountTokenProgram extends string = string, TAccountSystemProgram extends string = string, TAccountRent extends string = string> = {
    /** Unallocated edition V2 account with address as pda of ['metadata', program id, mint, 'edition'] */
    edition: Address<TAccountEdition>;
    /** Metadata mint */
    mint: Address<TAccountMint>;
    /** Update authority */
    updateAuthority: TransactionSigner<TAccountUpdateAuthority>;
    /** Mint authority on the metadata's mint - THIS WILL TRANSFER AUTHORITY AWAY FROM THIS KEY */
    mintAuthority: TransactionSigner<TAccountMintAuthority>;
    /** payer */
    payer: TransactionSigner<TAccountPayer>;
    /** Metadata account */
    metadata: Address<TAccountMetadata>;
    /** Token program */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Rent info */
    rent?: Address<TAccountRent>;
};
export declare function getCreateMasterEditionInstruction<TAccountEdition extends string, TAccountMint extends string, TAccountUpdateAuthority extends string, TAccountMintAuthority extends string, TAccountPayer extends string, TAccountMetadata extends string, TAccountTokenProgram extends string, TAccountSystemProgram extends string, TAccountRent extends string>(input: CreateMasterEditionInput<TAccountEdition, TAccountMint, TAccountUpdateAuthority, TAccountMintAuthority, TAccountPayer, TAccountMetadata, TAccountTokenProgram, TAccountSystemProgram, TAccountRent>): CreateMasterEditionInstruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountEdition, TAccountMint, TAccountUpdateAuthority, TAccountMintAuthority, TAccountPayer, TAccountMetadata, TAccountTokenProgram, TAccountSystemProgram, TAccountRent>;
export type ParsedCreateMasterEditionInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Unallocated edition V2 account with address as pda of ['metadata', program id, mint, 'edition'] */
        edition: TAccountMetas[0];
        /** Metadata mint */
        mint: TAccountMetas[1];
        /** Update authority */
        updateAuthority: TAccountMetas[2];
        /** Mint authority on the metadata's mint - THIS WILL TRANSFER AUTHORITY AWAY FROM THIS KEY */
        mintAuthority: TAccountMetas[3];
        /** payer */
        payer: TAccountMetas[4];
        /** Metadata account */
        metadata: TAccountMetas[5];
        /** Token program */
        tokenProgram: TAccountMetas[6];
        /** System program */
        systemProgram: TAccountMetas[7];
        /** Rent info */
        rent: TAccountMetas[8];
    };
    data: CreateMasterEditionInstructionData;
};
export declare function parseCreateMasterEditionInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCreateMasterEditionInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=createMasterEdition.d.ts.map