/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, ReadonlySignerAccount, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
import { PrintArgs, PrintArgsArgs } from '../types';
export type PrintInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountEditionMetadata extends string | IAccountMeta<string> = string, TAccountEdition extends string | IAccountMeta<string> = string, TAccountEditionMint extends string | IAccountMeta<string> = string, TAccountEditionTokenAccountOwner extends string | IAccountMeta<string> = string, TAccountEditionTokenAccount extends string | IAccountMeta<string> = string, TAccountEditionMintAuthority extends string | IAccountMeta<string> = string, TAccountEditionTokenRecord extends string | IAccountMeta<string> = string, TAccountMasterEdition extends string | IAccountMeta<string> = string, TAccountEditionMarkerPda extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountMasterTokenAccountOwner extends string | IAccountMeta<string> = string, TAccountMasterTokenAccount extends string | IAccountMeta<string> = string, TAccountMasterMetadata extends string | IAccountMeta<string> = string, TAccountUpdateAuthority extends string | IAccountMeta<string> = string, TAccountSplTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountSplAtaProgram extends string | IAccountMeta<string> = 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL', TAccountSysvarInstructions extends string | IAccountMeta<string> = 'Sysvar1nstructions1111111111111111111111111', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountEditionMetadata extends string ? WritableAccount<TAccountEditionMetadata> : TAccountEditionMetadata,
    TAccountEdition extends string ? WritableAccount<TAccountEdition> : TAccountEdition,
    TAccountEditionMint extends string ? WritableAccount<TAccountEditionMint> : TAccountEditionMint,
    TAccountEditionTokenAccountOwner extends string ? ReadonlyAccount<TAccountEditionTokenAccountOwner> : TAccountEditionTokenAccountOwner,
    TAccountEditionTokenAccount extends string ? WritableAccount<TAccountEditionTokenAccount> : TAccountEditionTokenAccount,
    TAccountEditionMintAuthority extends string ? ReadonlySignerAccount<TAccountEditionMintAuthority> & IAccountSignerMeta<TAccountEditionMintAuthority> : TAccountEditionMintAuthority,
    TAccountEditionTokenRecord extends string ? WritableAccount<TAccountEditionTokenRecord> : TAccountEditionTokenRecord,
    TAccountMasterEdition extends string ? WritableAccount<TAccountMasterEdition> : TAccountMasterEdition,
    TAccountEditionMarkerPda extends string ? WritableAccount<TAccountEditionMarkerPda> : TAccountEditionMarkerPda,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountMasterTokenAccountOwner extends string ? ReadonlyAccount<TAccountMasterTokenAccountOwner> : TAccountMasterTokenAccountOwner,
    TAccountMasterTokenAccount extends string ? ReadonlyAccount<TAccountMasterTokenAccount> : TAccountMasterTokenAccount,
    TAccountMasterMetadata extends string ? ReadonlyAccount<TAccountMasterMetadata> : TAccountMasterMetadata,
    TAccountUpdateAuthority extends string ? ReadonlyAccount<TAccountUpdateAuthority> : TAccountUpdateAuthority,
    TAccountSplTokenProgram extends string ? ReadonlyAccount<TAccountSplTokenProgram> : TAccountSplTokenProgram,
    TAccountSplAtaProgram extends string ? ReadonlyAccount<TAccountSplAtaProgram> : TAccountSplAtaProgram,
    TAccountSysvarInstructions extends string ? ReadonlyAccount<TAccountSysvarInstructions> : TAccountSysvarInstructions,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type PrintInstructionData = {
    discriminator: number;
    printArgs: PrintArgs;
};
export type PrintInstructionDataArgs = {
    printArgs: PrintArgsArgs;
};
export declare function getPrintInstructionDataEncoder(): Encoder<PrintInstructionDataArgs>;
export declare function getPrintInstructionDataDecoder(): Decoder<PrintInstructionData>;
export declare function getPrintInstructionDataCodec(): Codec<PrintInstructionDataArgs, PrintInstructionData>;
export type PrintInput<TAccountEditionMetadata extends string = string, TAccountEdition extends string = string, TAccountEditionMint extends string = string, TAccountEditionTokenAccountOwner extends string = string, TAccountEditionTokenAccount extends string = string, TAccountEditionMintAuthority extends string = string, TAccountEditionTokenRecord extends string = string, TAccountMasterEdition extends string = string, TAccountEditionMarkerPda extends string = string, TAccountPayer extends string = string, TAccountMasterTokenAccountOwner extends string = string, TAccountMasterTokenAccount extends string = string, TAccountMasterMetadata extends string = string, TAccountUpdateAuthority extends string = string, TAccountSplTokenProgram extends string = string, TAccountSplAtaProgram extends string = string, TAccountSysvarInstructions extends string = string, TAccountSystemProgram extends string = string> = {
    /** New Metadata key (pda of ['metadata', program id, mint id]) */
    editionMetadata: Address<TAccountEditionMetadata>;
    /** New Edition (pda of ['metadata', program id, mint id, 'edition']) */
    edition: Address<TAccountEdition>;
    /** Mint of new token - THIS WILL TRANSFER AUTHORITY AWAY FROM THIS KEY */
    editionMint: Address<TAccountEditionMint>;
    /** Owner of the token account of new token */
    editionTokenAccountOwner: Address<TAccountEditionTokenAccountOwner>;
    /** Token account of new token */
    editionTokenAccount: Address<TAccountEditionTokenAccount>;
    /** Mint authority of new mint */
    editionMintAuthority: TransactionSigner<TAccountEditionMintAuthority>;
    /** Token record account */
    editionTokenRecord?: Address<TAccountEditionTokenRecord>;
    /** Master Record Edition V2 (pda of ['metadata', program id, master metadata mint id, 'edition']) */
    masterEdition: Address<TAccountMasterEdition>;
    /** Edition pda to mark creation - will be checked for pre-existence. (pda of ['metadata', program id, master metadata mint id, 'edition', edition_number]) where edition_number is NOT the edition number you pass in args but actually edition_number = floor(edition/EDITION_MARKER_BIT_SIZE). */
    editionMarkerPda: Address<TAccountEditionMarkerPda>;
    /** payer */
    payer: TransactionSigner<TAccountPayer>;
    /** owner of token account containing master token */
    masterTokenAccountOwner: Address<TAccountMasterTokenAccountOwner> | TransactionSigner<TAccountMasterTokenAccountOwner>;
    /** token account containing token from master metadata mint */
    masterTokenAccount: Address<TAccountMasterTokenAccount>;
    /** Master record metadata account */
    masterMetadata: Address<TAccountMasterMetadata>;
    /** The update authority of the master edition. */
    updateAuthority: Address<TAccountUpdateAuthority>;
    /** Token program */
    splTokenProgram?: Address<TAccountSplTokenProgram>;
    /** SPL Associated Token Account program */
    splAtaProgram?: Address<TAccountSplAtaProgram>;
    /** Instructions sysvar account */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    printArgs: PrintInstructionDataArgs['printArgs'];
};
export declare function getPrintInstruction<TAccountEditionMetadata extends string, TAccountEdition extends string, TAccountEditionMint extends string, TAccountEditionTokenAccountOwner extends string, TAccountEditionTokenAccount extends string, TAccountEditionMintAuthority extends string, TAccountEditionTokenRecord extends string, TAccountMasterEdition extends string, TAccountEditionMarkerPda extends string, TAccountPayer extends string, TAccountMasterTokenAccountOwner extends string, TAccountMasterTokenAccount extends string, TAccountMasterMetadata extends string, TAccountUpdateAuthority extends string, TAccountSplTokenProgram extends string, TAccountSplAtaProgram extends string, TAccountSysvarInstructions extends string, TAccountSystemProgram extends string>(input: PrintInput<TAccountEditionMetadata, TAccountEdition, TAccountEditionMint, TAccountEditionTokenAccountOwner, TAccountEditionTokenAccount, TAccountEditionMintAuthority, TAccountEditionTokenRecord, TAccountMasterEdition, TAccountEditionMarkerPda, TAccountPayer, TAccountMasterTokenAccountOwner, TAccountMasterTokenAccount, TAccountMasterMetadata, TAccountUpdateAuthority, TAccountSplTokenProgram, TAccountSplAtaProgram, TAccountSysvarInstructions, TAccountSystemProgram>): PrintInstruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountEditionMetadata, TAccountEdition, TAccountEditionMint, TAccountEditionTokenAccountOwner, TAccountEditionTokenAccount, TAccountEditionMintAuthority, TAccountEditionTokenRecord, TAccountMasterEdition, TAccountEditionMarkerPda, TAccountPayer, (typeof input)['masterTokenAccountOwner'] extends TransactionSigner<TAccountMasterTokenAccountOwner> ? ReadonlySignerAccount<TAccountMasterTokenAccountOwner> & IAccountSignerMeta<TAccountMasterTokenAccountOwner> : TAccountMasterTokenAccountOwner, TAccountMasterTokenAccount, TAccountMasterMetadata, TAccountUpdateAuthority, TAccountSplTokenProgram, TAccountSplAtaProgram, TAccountSysvarInstructions, TAccountSystemProgram>;
export type ParsedPrintInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** New Metadata key (pda of ['metadata', program id, mint id]) */
        editionMetadata: TAccountMetas[0];
        /** New Edition (pda of ['metadata', program id, mint id, 'edition']) */
        edition: TAccountMetas[1];
        /** Mint of new token - THIS WILL TRANSFER AUTHORITY AWAY FROM THIS KEY */
        editionMint: TAccountMetas[2];
        /** Owner of the token account of new token */
        editionTokenAccountOwner: TAccountMetas[3];
        /** Token account of new token */
        editionTokenAccount: TAccountMetas[4];
        /** Mint authority of new mint */
        editionMintAuthority: TAccountMetas[5];
        /** Token record account */
        editionTokenRecord?: TAccountMetas[6] | undefined;
        /** Master Record Edition V2 (pda of ['metadata', program id, master metadata mint id, 'edition']) */
        masterEdition: TAccountMetas[7];
        /** Edition pda to mark creation - will be checked for pre-existence. (pda of ['metadata', program id, master metadata mint id, 'edition', edition_number]) where edition_number is NOT the edition number you pass in args but actually edition_number = floor(edition/EDITION_MARKER_BIT_SIZE). */
        editionMarkerPda: TAccountMetas[8];
        /** payer */
        payer: TAccountMetas[9];
        /** owner of token account containing master token */
        masterTokenAccountOwner: TAccountMetas[10];
        /** token account containing token from master metadata mint */
        masterTokenAccount: TAccountMetas[11];
        /** Master record metadata account */
        masterMetadata: TAccountMetas[12];
        /** The update authority of the master edition. */
        updateAuthority: TAccountMetas[13];
        /** Token program */
        splTokenProgram: TAccountMetas[14];
        /** SPL Associated Token Account program */
        splAtaProgram: TAccountMetas[15];
        /** Instructions sysvar account */
        sysvarInstructions: TAccountMetas[16];
        /** System program */
        systemProgram: TAccountMetas[17];
    };
    data: PrintInstructionData;
};
export declare function parsePrintInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedPrintInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=print.d.ts.map