/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, ReadonlySignerAccount, TransactionSigner, WritableAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
import { VerificationArgs, VerificationArgsArgs } from '../types';
export type UnverifyInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountDelegateRecord extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountCollectionMint extends string | IAccountMeta<string> = string, TAccountCollectionMetadata extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountSysvarInstructions extends string | IAccountMeta<string> = 'Sysvar1nstructions1111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountDelegateRecord extends string ? ReadonlyAccount<TAccountDelegateRecord> : TAccountDelegateRecord,
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountCollectionMint extends string ? ReadonlyAccount<TAccountCollectionMint> : TAccountCollectionMint,
    TAccountCollectionMetadata extends string ? WritableAccount<TAccountCollectionMetadata> : TAccountCollectionMetadata,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountSysvarInstructions extends string ? ReadonlyAccount<TAccountSysvarInstructions> : TAccountSysvarInstructions,
    ...TRemainingAccounts
]>;
export type UnverifyInstructionData = {
    discriminator: number;
    verificationArgs: VerificationArgs;
};
export type UnverifyInstructionDataArgs = {
    verificationArgs: VerificationArgsArgs;
};
export declare function getUnverifyInstructionDataEncoder(): Encoder<UnverifyInstructionDataArgs>;
export declare function getUnverifyInstructionDataDecoder(): Decoder<UnverifyInstructionData>;
export declare function getUnverifyInstructionDataCodec(): Codec<UnverifyInstructionDataArgs, UnverifyInstructionData>;
export type UnverifyInput<TAccountAuthority extends string = string, TAccountDelegateRecord extends string = string, TAccountMetadata extends string = string, TAccountCollectionMint extends string = string, TAccountCollectionMetadata extends string = string, TAccountSystemProgram extends string = string, TAccountSysvarInstructions extends string = string> = {
    /** Creator to verify, collection (or metadata if parent burned) update authority or delegate */
    authority: TransactionSigner<TAccountAuthority>;
    /** Delegate record PDA */
    delegateRecord?: Address<TAccountDelegateRecord>;
    /** Metadata account */
    metadata: Address<TAccountMetadata>;
    /** Mint of the Collection */
    collectionMint?: Address<TAccountCollectionMint>;
    /** Metadata Account of the Collection */
    collectionMetadata?: Address<TAccountCollectionMetadata>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Instructions sysvar account */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    verificationArgs: UnverifyInstructionDataArgs['verificationArgs'];
};
export declare function getUnverifyInstruction<TAccountAuthority extends string, TAccountDelegateRecord extends string, TAccountMetadata extends string, TAccountCollectionMint extends string, TAccountCollectionMetadata extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string>(input: UnverifyInput<TAccountAuthority, TAccountDelegateRecord, TAccountMetadata, TAccountCollectionMint, TAccountCollectionMetadata, TAccountSystemProgram, TAccountSysvarInstructions>): UnverifyInstruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountAuthority, TAccountDelegateRecord, TAccountMetadata, TAccountCollectionMint, TAccountCollectionMetadata, TAccountSystemProgram, TAccountSysvarInstructions>;
export type ParsedUnverifyInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Creator to verify, collection (or metadata if parent burned) update authority or delegate */
        authority: TAccountMetas[0];
        /** Delegate record PDA */
        delegateRecord?: TAccountMetas[1] | undefined;
        /** Metadata account */
        metadata: TAccountMetas[2];
        /** Mint of the Collection */
        collectionMint?: TAccountMetas[3] | undefined;
        /** Metadata Account of the Collection */
        collectionMetadata?: TAccountMetas[4] | undefined;
        /** System program */
        systemProgram: TAccountMetas[5];
        /** Instructions sysvar account */
        sysvarInstructions: TAccountMetas[6];
    };
    data: UnverifyInstructionData;
};
export declare function parseUnverifyInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedUnverifyInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=unverify.d.ts.map