/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
export type UnverifyCollectionInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountCollectionAuthority extends string | IAccountMeta<string> = string, TAccountCollectionMint extends string | IAccountMeta<string> = string, TAccountCollection extends string | IAccountMeta<string> = string, TAccountCollectionMasterEditionAccount extends string | IAccountMeta<string> = string, TAccountCollectionAuthorityRecord extends string | IAccountMeta<string> | undefined = undefined, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountCollectionAuthority extends string ? WritableSignerAccount<TAccountCollectionAuthority> & IAccountSignerMeta<TAccountCollectionAuthority> : TAccountCollectionAuthority,
    TAccountCollectionMint extends string ? ReadonlyAccount<TAccountCollectionMint> : TAccountCollectionMint,
    TAccountCollection extends string ? ReadonlyAccount<TAccountCollection> : TAccountCollection,
    TAccountCollectionMasterEditionAccount extends string ? ReadonlyAccount<TAccountCollectionMasterEditionAccount> : TAccountCollectionMasterEditionAccount,
    ...(TAccountCollectionAuthorityRecord extends undefined ? [] : [
        TAccountCollectionAuthorityRecord extends string ? ReadonlyAccount<TAccountCollectionAuthorityRecord> : TAccountCollectionAuthorityRecord
    ]),
    ...TRemainingAccounts
]>;
export type UnverifyCollectionInstructionData = {
    discriminator: number;
};
export type UnverifyCollectionInstructionDataArgs = {};
export declare function getUnverifyCollectionInstructionDataEncoder(): Encoder<UnverifyCollectionInstructionDataArgs>;
export declare function getUnverifyCollectionInstructionDataDecoder(): Decoder<UnverifyCollectionInstructionData>;
export declare function getUnverifyCollectionInstructionDataCodec(): Codec<UnverifyCollectionInstructionDataArgs, UnverifyCollectionInstructionData>;
export type UnverifyCollectionInput<TAccountMetadata extends string = string, TAccountCollectionAuthority extends string = string, TAccountCollectionMint extends string = string, TAccountCollection extends string = string, TAccountCollectionMasterEditionAccount extends string = string, TAccountCollectionAuthorityRecord extends string = string> = {
    /** Metadata account */
    metadata: Address<TAccountMetadata>;
    /** Collection Authority */
    collectionAuthority: TransactionSigner<TAccountCollectionAuthority>;
    /** Mint of the Collection */
    collectionMint: Address<TAccountCollectionMint>;
    /** Metadata Account of the Collection */
    collection: Address<TAccountCollection>;
    /** MasterEdition2 Account of the Collection Token */
    collectionMasterEditionAccount: Address<TAccountCollectionMasterEditionAccount>;
    /** Collection Authority Record PDA */
    collectionAuthorityRecord?: Address<TAccountCollectionAuthorityRecord>;
};
export declare function getUnverifyCollectionInstruction<TAccountMetadata extends string, TAccountCollectionAuthority extends string, TAccountCollectionMint extends string, TAccountCollection extends string, TAccountCollectionMasterEditionAccount extends string, TAccountCollectionAuthorityRecord extends string>(input: UnverifyCollectionInput<TAccountMetadata, TAccountCollectionAuthority, TAccountCollectionMint, TAccountCollection, TAccountCollectionMasterEditionAccount, TAccountCollectionAuthorityRecord>): UnverifyCollectionInstruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetadata, TAccountCollectionAuthority, TAccountCollectionMint, TAccountCollection, TAccountCollectionMasterEditionAccount, TAccountCollectionAuthorityRecord>;
export type ParsedUnverifyCollectionInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Metadata account */
        metadata: TAccountMetas[0];
        /** Collection Authority */
        collectionAuthority: TAccountMetas[1];
        /** Mint of the Collection */
        collectionMint: TAccountMetas[2];
        /** Metadata Account of the Collection */
        collection: TAccountMetas[3];
        /** MasterEdition2 Account of the Collection Token */
        collectionMasterEditionAccount: TAccountMetas[4];
        /** Collection Authority Record PDA */
        collectionAuthorityRecord?: TAccountMetas[5] | undefined;
    };
    data: UnverifyCollectionInstructionData;
};
export declare function parseUnverifyCollectionInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedUnverifyCollectionInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=unverifyCollection.d.ts.map