/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
export type UtilizeInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountTokenAccount extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountUseAuthority extends string | IAccountMeta<string> = string, TAccountOwner extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountAtaProgram extends string | IAccountMeta<string> = 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountRent extends string | IAccountMeta<string> = 'SysvarRent111111111111111111111111111111111', TAccountUseAuthorityRecord extends string | IAccountMeta<string> | undefined = undefined, TAccountBurner extends string | IAccountMeta<string> | undefined = undefined, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountTokenAccount extends string ? WritableAccount<TAccountTokenAccount> : TAccountTokenAccount,
    TAccountMint extends string ? WritableAccount<TAccountMint> : TAccountMint,
    TAccountUseAuthority extends string ? WritableSignerAccount<TAccountUseAuthority> & IAccountSignerMeta<TAccountUseAuthority> : TAccountUseAuthority,
    TAccountOwner extends string ? ReadonlyAccount<TAccountOwner> : TAccountOwner,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountAtaProgram extends string ? ReadonlyAccount<TAccountAtaProgram> : TAccountAtaProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountRent extends string ? ReadonlyAccount<TAccountRent> : TAccountRent,
    ...(TAccountUseAuthorityRecord extends undefined ? [] : [
        TAccountUseAuthorityRecord extends string ? WritableAccount<TAccountUseAuthorityRecord> : TAccountUseAuthorityRecord
    ]),
    ...(TAccountBurner extends undefined ? [] : [
        TAccountBurner extends string ? ReadonlyAccount<TAccountBurner> : TAccountBurner
    ]),
    ...TRemainingAccounts
]>;
export type UtilizeInstructionData = {
    discriminator: number;
    numberOfUses: bigint;
};
export type UtilizeInstructionDataArgs = {
    numberOfUses: number | bigint;
};
export declare function getUtilizeInstructionDataEncoder(): Encoder<UtilizeInstructionDataArgs>;
export declare function getUtilizeInstructionDataDecoder(): Decoder<UtilizeInstructionData>;
export declare function getUtilizeInstructionDataCodec(): Codec<UtilizeInstructionDataArgs, UtilizeInstructionData>;
export type UtilizeInput<TAccountMetadata extends string = string, TAccountTokenAccount extends string = string, TAccountMint extends string = string, TAccountUseAuthority extends string = string, TAccountOwner extends string = string, TAccountTokenProgram extends string = string, TAccountAtaProgram extends string = string, TAccountSystemProgram extends string = string, TAccountRent extends string = string, TAccountUseAuthorityRecord extends string = string, TAccountBurner extends string = string> = {
    /** Metadata account */
    metadata: Address<TAccountMetadata>;
    /** Token Account Of NFT */
    tokenAccount: Address<TAccountTokenAccount>;
    /** Mint of the Metadata */
    mint: Address<TAccountMint>;
    /** A Use Authority / Can be the current Owner of the NFT */
    useAuthority: TransactionSigner<TAccountUseAuthority>;
    /** Owner */
    owner: Address<TAccountOwner>;
    /** Token program */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** Associated Token program */
    ataProgram?: Address<TAccountAtaProgram>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Rent info */
    rent?: Address<TAccountRent>;
    /** Use Authority Record PDA If present the program Assumes a delegated use authority */
    useAuthorityRecord?: Address<TAccountUseAuthorityRecord>;
    /** Program As Signer (Burner) */
    burner?: Address<TAccountBurner>;
    numberOfUses: UtilizeInstructionDataArgs['numberOfUses'];
};
export declare function getUtilizeInstruction<TAccountMetadata extends string, TAccountTokenAccount extends string, TAccountMint extends string, TAccountUseAuthority extends string, TAccountOwner extends string, TAccountTokenProgram extends string, TAccountAtaProgram extends string, TAccountSystemProgram extends string, TAccountRent extends string, TAccountUseAuthorityRecord extends string, TAccountBurner extends string>(input: UtilizeInput<TAccountMetadata, TAccountTokenAccount, TAccountMint, TAccountUseAuthority, TAccountOwner, TAccountTokenProgram, TAccountAtaProgram, TAccountSystemProgram, TAccountRent, TAccountUseAuthorityRecord, TAccountBurner>): UtilizeInstruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetadata, TAccountTokenAccount, TAccountMint, TAccountUseAuthority, TAccountOwner, TAccountTokenProgram, TAccountAtaProgram, TAccountSystemProgram, TAccountRent, TAccountUseAuthorityRecord, TAccountBurner>;
export type ParsedUtilizeInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Metadata account */
        metadata: TAccountMetas[0];
        /** Token Account Of NFT */
        tokenAccount: TAccountMetas[1];
        /** Mint of the Metadata */
        mint: TAccountMetas[2];
        /** A Use Authority / Can be the current Owner of the NFT */
        useAuthority: TAccountMetas[3];
        /** Owner */
        owner: TAccountMetas[4];
        /** Token program */
        tokenProgram: TAccountMetas[5];
        /** Associated Token program */
        ataProgram: TAccountMetas[6];
        /** System program */
        systemProgram: TAccountMetas[7];
        /** Rent info */
        rent: TAccountMetas[8];
        /** Use Authority Record PDA If present the program Assumes a delegated use authority */
        useAuthorityRecord?: TAccountMetas[9] | undefined;
        /** Program As Signer (Burner) */
        burner?: TAccountMetas[10] | undefined;
    };
    data: UtilizeInstructionData;
};
export declare function parseUtilizeInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedUtilizeInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=utilize.d.ts.map